//
//  rssAppDelegate.m
//  rss
//
//  Created by kunii on 09/09/13.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "rssAppDelegate.h"
#import "RootViewController.h"


@implementation rssAppDelegate

@synthesize window;
@synthesize navigationController;


#pragma mark -
#pragma mark Application lifecycle

- (void)applicationDidFinishLaunching:(UIApplication *)application {    
    
    // Override point for customization after app launch    
	
	[window addSubview:[navigationController view]];
    [window makeKeyAndVisible];

	htmlstring =[[NSMutableString alloc] init];
#define USE_GET_METHOD 0	//	GETを試す時は 1 にする。
#if USE_GET_METHOD		//	GETを使う場合
	// URLを指定する
	NSURLRequest* request = [NSURLRequest requestWithURL:[NSURL URLWithString:@"http://localhost/test.php?name=test+data&location=osaka%2Cjapan"]];
#else					//	POSTを使う場合
	// URLを指定する
	NSMutableURLRequest* request = [[[NSMutableURLRequest alloc] init] autorelease];
	[request setURL:[NSURL URLWithString:@"http://localhost/test.php"]];
	[request setHTTPMethod:@"POST"];
	#define USEX_WWW_FORM_URLENCODED 0	//	application/x-www-form-urlencoded指定を使うなら 1
	#if USEX_WWW_FORM_URLENCODED	
		[request addValue:@"application/x-www-form-urlencoded" forHTTPHeaderField: @"Content-Type"];
		//	内容部作成
		NSMutableData *body = [NSMutableData data];
		[body appendData:[[NSString stringWithFormat:@"name=test+data&location=osaka%%2Cjapan"] dataUsingEncoding:NSUTF8StringEncoding]];
	#else	//	multipart/form-dataを使う
		NSString *boundary = [NSString stringWithString:@"xcc2009"];	//	境界文字列
		NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",boundary];
		[request addValue:contentType forHTTPHeaderField: @"Content-Type"];
		//	内容部作成
		NSMutableData *body = [NSMutableData data];
		//	name=test dataの設定
		[body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"Content-Disposition: form-data; name=\"name\"\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"Content-Type: text/plain;charset=utf8\r\n\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"test data"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
		//	location=osaka,japanの設定
		[body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"Content-Disposition: form-data; name=\"location\"\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"Content-Type: text/plain;charset=utf8\r\n\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithString:@"osaka,japan"] dataUsingEncoding:NSUTF8StringEncoding]];
		[body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	#endif
	//	内容物追加
	[request setHTTPBody:body];
#endif
	// URLコネクションを作る
	[NSURLConnection connectionWithRequest:request delegate:self];
}

- (void)connectionDidFinishLoading:(NSURLConnection*)connection
{
	UIWebView* webView = (UIWebView*)[(UIView*)[(UITableView*)[self.window viewWithTag:TABLE_VIEW_TAG] cellForRowAtIndexPath:[NSIndexPath indexPathForRow:0 inSection:0]] viewWithTag:WEB_VIEW_TAG];
	[webView loadHTMLString:(NSString *)htmlstring baseURL:[NSURL URLWithString:@"http://localhost/test.php"]];
}

- (void)connection:(NSURLConnection*)connection
        didReceiveData:(NSData*)data
{
	char* p = (char*)[data bytes];
	int len = [data length];
	while (len-- > 0) {
		putchar(*p++);
	}
	//	dataをhtmlstring側に保存していく。
	len = [data length];
	char* str = (char*)malloc(len + 1);
	memcpy(str, [data bytes], len);
	str[len] = 0;
	[htmlstring appendString:[NSString stringWithCString:str encoding:NSASCIIStringEncoding]];
	free(str);
}

- (void)applicationWillTerminate:(UIApplication *)application {
	// Save data if appropriate
}


#pragma mark -
#pragma mark Memory management

- (void)dealloc {
	[navigationController release];
	[window release];
	[htmlstring release];
	[super dealloc];
}


@end

